		save
		listing off   ; kein Listing ber diesen File

		ifndef  stddef51inc     ; verhindert Mehrfacheinbindung

stddef51inc     equ     1

;----------------------------------------------------------------------------
; erstmal die Sachen, die es (fast) berall gibt :

P0		SFRB	80h		; I/O-Ports
P1		SFRB	90h
P2		SFRB	0a0h
P3		SFRB	0b0h
RD		BIT	P3.7		; Port 3: Schreibleitung
WR		BIT	P3.6		;         Leseleitung
T1              BIT     P3.5            ;   Testleitung 1
T0		BIT	P3.4		;	  Testleitung 0
INT1		BIT	P3.3		;         ext. Interrupt 1
INT0		BIT	P3.2		;	  ext. Interrupt 0
TXD		BIT	P3.1		;	  ser. Ausgang
RXD		BIT	P3.0		;	  ser. Eingang
		if	MomCPU=80C320H
TXD1		 BIT	P1.3		; zweiter ser. Ausgang
RXD1		 BIT	P1.2		; zweiter ser. Eingang
		endif

;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

SP		SFR	81h		; Stapelzeiger
DPL		SFR	82h		; Datenzeiger Bit 0..7
DPH		SFR	83h		;      "      Bit 8..15
		if	MomCPU=80C320H
DPL0		 SFR	DPL
DPH0		 SFR	DPH
DPL1		 SFR	84h		; zweiter Datenzeiger 80C320
DPH1		 SFR	DPL1+1
DPS		 SFR	86h		; Bit 0=Umschaltung DPTR0<-->DPTR1
		endif
PSW		SFRB	0d0h		; Statuswort
CY		BIT	0d7h
AC		BIT	0d6h
F0		BIT	0d5h
RS1		BIT	0d4h
RS0		BIT	0d3h
OV		BIT	0d2h
P		BIT	0d0h
ACC		SFRB	0e0h		; Akkumulator
B		SFRB	0f0h		; Hilfsakku fr MUL/DIV

;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

SCON		SFRB	98h		; ser. Schnittstelle: Steuerregister
SM0		BIT     SCON.7          ; Betriebsarten
SM1		BIT     SCON.6
SM2		BIT     SCON.5
REN		BIT	SCON.4		; Empfangssperre
TB8		BIT	SCON.3		; 9. zu sendendes Bit
RB8		BIT	SCON.2		; 9. empfangenes Bit
TI		BIT	SCON.1		; Senderinterruptflag
RI		BIT	SCON.0		; Empfngerinterruptflag
SBUF		SFR	99h		;  "         "        Datenregister

		if	MomCPU=80C320H	; Register zweite serielle Schnittstelle
SCON0		 SFR	SCON
SBUF0		 SFR    SBUF
SCON1		 SFR	0c0h		; Steuerregister
SBUF1            SFR    0c1h            ; Datenregister
		endif

;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

PCON		SFR	87h		; "Power-Management"

;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

TCON		SFRB	88h		; Timer 0/1 Steuerregister
TF1		BIT	TCON.7		; berlauf Timer 1
TR1		BIT	TCON.6		; Timer 1 laufenlassen
TF0		BIT	TCON.5		; berlauf Timer 0
TR0		BIT	TCON.4		; Timer 0 laufenlassen
IE1		BIT	TCON.3		; Externer Interrupt 1 aufgetreten
IT1		BIT	TCON.2		; Einstellung Triggerflanke externer Interrupt 1
IE0		BIT	TCON.1		; Externer Interrupt 0 aufgetreten
IT0		BIT	TCON.0		; Einstellung Triggerflanke externer Interrupt 0
TMOD		SFR 	89h		; Timer 0/1 Betriebsartenregister
TL0		SFR	8ah		; Daten Timer 0
TL1		SFR	8bh
TH0		SFR	8ch		; Daten Timer 1
TH1		SFR	8dh

IE		 SFRB	0a8h		; Interruptfreigaben
IEC              SFRB   IE
EA		 BIT	IE.7		; generelle Interruptsperre
ES		 BIT    IE.4		; Interrupts ser. Schnittstelle freigeben
ET1		 BIT	IE.3		; Interrupt Timer 1 freigeben
EX1		 BIT	IE.2		; externen Interrupt 1 freigeben
ET0		 BIT	IE.1		; Interrupt Timer 0 freigeben
EX0		 BIT	IE.0		; externen Interrupt 0 freigeben
IP		 SFRB	0b8h		; Interruptprioritten
IPC              SFRB   IP
PS		 BIT	IP.4		; Prioritt serieller Interrupt
PT1		 BIT	IP.3		; Prioritt Interrupt Timer 1
PX1		 BIT	IP.2		; Prioritt externer Interrupt 1
PT0		 BIT	IP.1		; Prioritt Interrupt Timer 0
PX0		 BIT	IP.0		; Prioritt externer Interrupt 0
		 if 	MomCPU=8052h
ET2		  BIT	IE.5		; Interrupt Timer 2 freigeben
PT2		  BIT	IP.5		; Prioritt Interrupt Timer 2
		 endif


;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
; kein Timer 2 beim 8051

		if	MOMCPU<>8051h
T2CON	 	 SFRB	0c8h		; Steuerregister Timer 2
TL2	 	 SFR	0cch		; Daten Timer 2
TH2	 	 SFR	0cdh
		 if	MOMCPU=8052h
RCAP2L	 	  SFR	0cah		; Capture-Register
RCAP2H	 	  SFR	0cbh
TF2		  BIT	T2CON.7		; Overflow Timer 2
EXF2		  BIT	T2CON.6		; Reload aufgetreten
RCLK		  BIT	T2CON.5		; Timer 2 liefert RxD-Takt
TCLK		  BIT	T2CON.4		; Timer 2 liefert TxD-Takt
EXEN2		  BIT	T2CON.3		; externer Enable Timer 2
TR2		  BIT	T2CON.2		; Timer 2 starten
CT2		  BIT	T2CON.1		; Timer 2 als Zhler
CPRL2		  BIT	T2CON.0		; Capture erlauben
		 elseif
CRCL		  SFR   0cah		; andere Namen beim 80515 !!
CRCH		  SFR	0cbh
T2PS		  BIT	T2CON.7
I3FR		  BIT	T2CON.6
I2FR		  BIT	T2CON.5
T2R1		  BIT	T2CON.4
T2R0		  BIT	T2CON.3
T2CM		  BIT	T2CON.2
T2I1		  BIT	T2CON.1
T2I0		  BIT	T2CON.0
		 endif
		endif

;---------------------------------------------------------------------------
		; oberes Byte eines 16-Bit-Wortes:
hi              function x,(x>>8)&255

		; dito unteres Byte:
lo              function x,x&255

                endif

                restore                 ; wieder erlauben

