.include "m8def.inc"
		.org 0

rjmp 	ISR_RESET		; Reset Handler
rjmp	ISR_EXT_INT0		; IRQ0 Handler
rjmp	ISR_EXT_INT1		; IRQ1 Handler
rjmp	ISR_PCINT0		; PCINT0 Handler
rjmp	ISR_PCINT1		; PCINT1 Handler
rjmp	ISR_PCINT2		; PCINT2 Handler
rjmp	ISR_WDT		; Watchdog Timer Handler
rjmp	ISR_TIM2_COMPA	; Timer2 Compare A Handler
rjmp	ISR_TIM2_COMPB	; Timer2 Compare B Handler
rjmp	ISR_TIM2_OVF		; Timer2 Overflow Handler
rjmp	ISR_TIM1_CAPT		; Timer1 Capture Handler
rjmp	ISR_TIM1_COMPA	; Timer1 Compare A Handler
rjmp	ISR_TIM1_COMPB	; Timer1 Compare B Handler
rjmp	ISR_TIM1_OVF		; Timer1 Overflow Handler
rjmp	ISR_TIM0_COMPA	; Timer0 Compare A Handler
rjmp	ISR_TIM0_COMPB	; Timer0 Compare B Handler
rjmp	ISR_TIM0_OVF		; Timer0 Overflow Handler
rjmp	ISR_SPI_STC		; SPI Transfer Complete Handler
rjmp	ISR_USART_RXC		; USART, RX Complete Handler
rjmp	ISR_USART_UDRE	; USART, UDR Empty Handler
rjmp	ISR_USART_TXC		; USART, TX Complete Handler
rjmp	ISR_ADC		; ADC Conversion Complete Handler
rjmp	ISR_EE_RDY		; EEPROM Ready Handler
rjmp	ISR_ANA_COMP		; Analog Comparator Handler
rjmp	ISR_TWI		; 2-wire Serial Interface Handler
rjmp	ISR_SPM_RDY		; Store Program Memory Ready Handler


	;================================================
steptab:
	;Q8 Q7 Q6 Q5 Q4 Q3 Q2 Q1
	;frei I02 I12 Ph2 I01 Ph1 I11 frei
	.db 0b00001110,0b00000110
	.db 0b01001100,0b00100100
	.db 0b01110100,0b00110100
	.db 0b01011100,0b00010110
	.db 0b00011010,0b00010010
	.db 0b01011000,0b00110000
	.db 0b01100000,0b00100000
	.db 0b01001000,0b00000010
	;--------------------------------------------------
	;ISR's

ISR_EXT_INT0:	; IRQ0 Handler
	reti

ISR_EXT_INT1:	; IRQ1 Handler
	reti

ISR_PCINT0:		; PCINT0 Handler
	reti

ISR_PCINT1:		; PCINT1 Handler
	reti

ISR_PCINT2:		; PCINT2 Handler
	reti

ISR_WDT:		; Watchdog Timer Handler
	reti

ISR_TIM2_COMPA:	; Timer2 Compare A Handler
	reti

ISR_TIM2_COMPB:	; Timer2 Compare B Handler
	reti

ISR_TIM2_OVF:	; Timer2 Overflow Handler
	reti

ISR_TIM1_CAPT:	; Timer1 Capture Handler
	reti

ISR_TIM1_COMPA:	; Timer1 Compare A Handler
	reti

ISR_TIM1_COMPB:	; Timer1 Compare B Handler
	reti

ISR_TIM1_OVF:	; Timer1 Overflow Handler
	reti

ISR_TIM0_COMPA:	; Timer0 Compare A Handler
	reti

ISR_TIM0_COMPB:	; Timer0 Compare B Handler
	reti

ISR_TIM0_OVF:	; Timer0 Overflow Handler
	reti

ISR_SPI_STC:	; SPI Transfer Complete Handler
	reti

ISR_USART_RXC:	; USART, RX Complete Handler
	reti

ISR_USART_UDRE:	; USART, UDR Empty Handler
	reti

ISR_USART_TXC:	; USART, TX Complete Handler
	reti

ISR_ADC:		; ADC Conversion Complete Handler
	reti

ISR_EE_RDY:		; EEPROM Ready Handler
	reti

ISR_ANA_COMP:	; Analog Comparator Handler
	reti

ISR_TWI:		; 2-wire Serial Interface Handler
	reti

ISR_SPM_RDY:	; Store Program Memory Ready Handler
	reti

	;--------------------------------------------------

ISR_RESET:
	;Stackpointer (re)initialisieren
	ldi		r16, high(RAMEND)
	out 	SPH,r16
	ldi 	r16, low(RAMEND)
	out 	SPL,r16


	ldi	r16,255
	out	ddrb,r16


	;Baudrate einstellen
	; Set baud rate
	;Teilerfaktor fr 12MHz (/16) und 4800 Baud: 312
	ldi	r17,high(156)
	ldi	r16,low(156)
	out UBRRH, r17
	out UBRRL, r16
	; Enable receiver and transmitter
	ldi r16, (1<<RXEN)|(1<<TXEN)
	out UCSRB,r16
	; Set frame format: 8data, 2stop bit
	ldi r16, (1<<URSEL)|(1<<USBS)|(3<<UCSZ0)
	out UCSRC,r16


	;SPI_MasterInit:
	; Enable SPI, Master, set clock rate fck/2
	ldi	r17,1<<SPI2X
	out	SPSR,r17
	ldi r17,(1<<SPE)|(1<<MSTR)
	out SPCR,r17
	

	out SPDR,r16	;erste SPI-Ausgabe


	rcall	print
	.db		"Hallo!",0,0

	sbi	portb,1

loop:
	rcall	print
	.db		0x0d,0x0a,">",0
	rcall	rxchar
	rcall	txchar	

	cpi		r16,'+'
	breq	plus

	cpi		r16,'-'
	breq	minus

	cpi		r16,' '
	breq	exec

	rcall	print
	.db		"????",0x0d,0x0a,0,0
	rjmp	loop


plus:
	sbi		portb,1
	rjmp	loop

minus:
	ldi		r16,255		;Schrittmotortreiber aus
	rcall	SpiOut
	rcall	SpiOut
	rcall	SpiOut
	rcall	SpiOut
	rcall	SpiEna
	rjmp	loop

exec:
	ldi		xl,low(delta1)
	ldi		xh,high(delta1)

	clr		r16
	st		x+,r16
	st		x+,r16
	st		x+,r16
	ldi		r16,0x10
	st		x+,r16

	clr		r16
	st		x+,r16
	st		x+,r16
	st		x+,r16
	ldi		r16,0x08
	st		x+,r16

	clr		r16
	st		x+,r16
	st		x+,r16
	st		x+,r16
	ldi		r16,0x04
	st		x+,r16

	clr		r16
	st		x+,r16
	st		x+,r16
	st		x+,r16
	ldi		r16,0x02
	st		x+,r16

	ldi		xl,low(runctr)
	ldi		xh,high(runctr)
	ldi		r16,low(1000)
	st		x+,r16
	ldi		r16,high(1000)
	st		x+,r16
	clr		r16
	st		x+,r16
	st		x+,r16
	rcall	StepRun
	rjmp	loop

	;================================================
StepRun:
	rcall	OneStep

	rcall	Delay

	ldi		xl,low(runctr)		;Rundenzhler dekrementieren
	ldi		xh,high(runctr)
	ld		r16,x
	subi	r16,1
	st		x+,r16
	mov		r0,r16
	ld		r16,x
	sbci	r16,0
	st		x+,r16
	or		r0,r16
	ld		r16,x
	sbci	r16,0
	st		x+,r16
	or		r0,r16
	ld		r16,x
	sbci	r16,0
	st		x+,r16
	or		r0,r16
	brne	StepRun

	ret
	;================================================
SpiOut:
	; Wait for transmission complete
	sbis SPSR,SPIF
	rjmp SpiOut
	out SPDR,r16
	ret

SpiEna:
	; Wait for transmission complete
	sbis SPSR,SPIF
	rjmp SpiEna
	sbi		portb,2		;Latch Enable
	cbi		portb,2
	ret

	;================================================
OneStep:
	ldi		xl,low(delta1)
	ldi		xh,high(delta1)
	ldi		yl,low(motor1)
	ldi		yh,high(motor1)
	ldi		r17,4	;Runden (Motoren)
OneStepLoop:
	;Werte addieren
	ld		r0,x+
	ld		r16,y
	add		r16,r0
	st		y+,r16

	ld		r0,x+
	ld		r16,y
	adc		r16,r0
	st		y+,r16

	ld		r0,x+
	ld		r16,y
	adc		r16,r0
	st		y+,r16

	ld		r0,x+
	ld		r16,y
	adc		r16,r0
	st		y+,r16

	swap	r16
	andi	r16,15
	ldi		zh,high(steptab<<1)
	ldi		zl,low(steptab<<1)
	add		zl,r16
	lpm	r16,z
	rcall	SpiOut
	dec		r17
	brne	OneStepLoop
	rcall	SpiEna
	ret
	;================================================
Delay:
	push	r16
	push	r17
	ldi		r16,low(65000)
	ldi		r17,high(65000)
DelayLoop:
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	subi	r16,1
	sbci	r17,1
	brcc	DelayLoop
	pop		r17
	pop		r16
	ret
	;================================================

ldez:
	push	r0
	push	r1
	push	r16
	push	r18
	push	r19
	ldi		r18,low(10000)
	ldi		r19,high(10000)
	rcall	ldiv
	ldi		r18,low(1000)
	ldi		r19,high(1000)
	rcall	ldiv
	ldi		r18,low(100)
	ldi		r19,high(100)
	rcall	ldiv
	ldi		r18,low(10)
	ldi		r19,high(10)
	rcall	ldiv
	ldi		r18,low(1)
	ldi		r19,high(1)
	rcall	ldiv
	pop		r19
	pop		r18
	pop		r16
	pop		r1
	pop		r0
	ret

ldiv:
	ldi		r16,'0'
ldiv1:
	inc		r16
	sub		r0,r18
	sbc		r1,r19
	brcc	ldiv1
	dec		r16
	add		r0,r18
	adc		r1,r19
	rcall	txchar
	ret

	;================================================
ladr:
	push	r16
	mov		r16,r17
	rcall	lbyte
	pop	r16
lbyte:
	swap	r16
	rcall	lnible
	swap	r16
lnible:
	push	r16
	andi	r16,15			;obere Bits ausblenden
	subi	r16,-'0'		;'0' addieren
	cpi		r16,':'
	brlo	lnible1
	subi	r16,-('A'-':')
lnible1:
	rcall	txchar
	pop		r16
	ret

	;================================================

	;Zeichen in R16 senden
txchar:
	; Wait for empty transmit buffer
	sbis UCSRA,UDRE
	rjmp txchar
	; Put data (r16) into buffer, sends the data
	out UDR,r16
	ret

rxchar:
	; Wait for data to be received
	sbis UCSRA, RXC
	rjmp rxchar
	; Get and return received data from buffer
	in r16, UDR
	ret

	;================================================

print:
	pop		zh
	pop		zl
	;X verdoppeln von Wordadresse auf Byteadresse
	lsl		zl	;rechts ne NULL einschieben
	rol		zh	;und durch CY

print1:
	lpm		r16,z++
	or		r16,r16
	breq	printx
	rcall	txchar
	rjmp	print1
printx:
	;X halbieren, von Byteadrese auf Wordadresse
	lsr		zh	;links ne NULL einschieben
	ror		zl	;und durch CY

	push	zl
	push	zh
	ret



	.dseg
	.org 0x60
delta1:
	.db	0,0,0,0
delta2:
	.db	0,0,0,0
delta3:
	.db	0,0,0,0
delta4:
	.db	0,0,0,0

motor1:
	.db	0,0,0,0
motor2:
	.db	0,0,0,0
motor3:
	.db	0,0,0,0
motor4:
	.db	0,0,0,0

runctr:
	.db	0,0,0,0
